# generated by datamodel-codegen:
#   filename:  OpenAPIdoc.yaml
#   timestamp: 2023-04-11T07:59:56+00:00

from __future__ import annotations

from datetime import datetime, date
from enum import Enum
from typing import Any, Dict, List, Optional, Union
from pandas import DataFrame

from pydantic import BaseModel, Field, constr


class Error(BaseModel):
    field: Optional[str] = None
    message: Optional[str] = None


class ErrorResponse(BaseModel):
    status: Optional[int] = None
    message: Optional[str] = None
    stackTrace: Optional[str] = None
    errors: Optional[List[Error]] = None


class ChangeTemperatureDto(BaseModel):
    temperature: int
    devEUI: str


class AuthorizationTarget(BaseModel):
    name: Optional[str] = None
    id: Optional[int] = None


class Role(Enum):
    ADMIN = 'ADMIN'
    ORGANISATION_MANAGER = 'ORGANISATION_MANAGER'
    BUILDING_MANAGER = 'BUILDING_MANAGER'
    ROOM_MANAGER = 'ROOM_MANAGER'
    ROOM_USER = 'ROOM_USER'


class ResourceDto(BaseModel):
    role: Optional[Role] = None
    resource: Optional[AuthorizationTarget] = None


class Status(Enum):
    ACTIVE = 'ACTIVE'
    BLOCKED = 'BLOCKED'
    PARENT_BLOCKED = 'PARENT_BLOCKED'


class GeoPoint(BaseModel):
    latitude: Optional[float] = None
    longitude: Optional[float] = None


class JsonNode(BaseModel):
    pass


class Status4Enum(Enum):
    INACTIVE = 'INACTIVE'
    ACTIVE = 'ACTIVE'


class Status4(BaseModel):
    __root__: Optional[Status4Enum] = None


class DeviceModelDto(BaseModel):
    id: Optional[int] = None
    name: constr(min_length=0, max_length=100)
    manufacturer: constr(min_length=0, max_length=100)
    attributes: List[str]


class IntegrationType(Enum):
    CHIRPSTACK = 'CHIRPSTACK'
    MQTT = 'MQTT'
    IC_METER = 'IC_METER'
    DANFOSS = 'DANFOSS'
    OS2IOT = 'OS2IOT'


class Data(BaseModel):
    time: Optional[datetime] = None
    values: Optional[Dict[str, Any]] = None


class SensorDataExtDto(BaseModel):
    devId: Optional[str] = None
    data: Optional[Union[List[Data],DataFrame]] = None

    class Config:
        arbitrary_types_allowed = True


class BuildingDto(BaseModel):
    id: Optional[int] = None
    status: Optional[Status] = None
    name: Optional[constr(min_length=0, max_length=200)] = None
    country: Optional[constr(min_length=0, max_length=2)] = None
    address: Optional[constr(min_length=0, max_length=100)] = None
    zipCode: Optional[constr(min_length=0, max_length=10)] = None
    city: Optional[constr(min_length=0, max_length=100)] = None
    timeZone: Optional[constr(min_length=0, max_length=64)] = None
    organisation: OrganisationDto = None
    coordinates: Optional[GeoPoint] = None
    maps: Optional[List[MapDto]] = []


class LocationDto(BaseModel):
    id: Optional[int] = None
    status: Optional[Status] = None
    name: Optional[constr(min_length=1, max_length=100)] = None
    nameAlternate: Optional[constr(min_length=0, max_length=100)] = None
    map: MapDto = None
    locationProfile: Optional[LocationProfileDto] = None
    schedulerProfile: Optional[SchedulerProfileDto] = None
    points: Optional[List[Dict[str, float]]] = None


class LocationProfileDto(BaseModel):
    id: Optional[int] = None
    organisation: Optional[OrganisationDto] = None
    name: Optional[constr(min_length=0, max_length=200)] = None
    parameters: Optional[JsonNode] = None
    version: Optional[int] = None


class MapDto(BaseModel):
    id: Optional[int] = None
    status: Optional[Status] = None
    name: Optional[constr(min_length=0, max_length=100)] = None
    building: Optional[BuildingDto] = None
    image: Optional[str] = None


class OrganisationDto(BaseModel):
    id: Optional[int] = None
    status: Optional[Status] = None
    name: Optional[constr(min_length=0, max_length=50)] = None
    country: Optional[constr(min_length=0, max_length=2)] = None
    address: Optional[constr(min_length=0, max_length=100)] = None
    address2: Optional[constr(min_length=0, max_length=100)] = None
    zipCode: Optional[constr(min_length=0, max_length=10)] = None
    city: Optional[constr(min_length=0, max_length=100)] = None
    registrationCode: Optional[constr(min_length=0, max_length=100)] = None
    buildings: Optional[List[BuildingDto]] = []
    locationProfiles: Optional[List[LocationProfileDto]] = []
    schedulerProfiles: Optional[List[SchedulerProfileDto]] = []


class SchedulerProfileDto(BaseModel):
    id: Optional[int] = None
    name: Optional[constr(min_length=0, max_length=200)] = None
    settings: JsonNode
    status: Optional[Status4] = None
    organisation: Optional[OrganisationDto] = None
    locations: Optional[List[LocationDto]] = []


class DeviceDto(BaseModel):
    id: Optional[int] = None
    externalId: constr(min_length=0, max_length=100)
    deviceModel: DeviceModelDto
    alias: Optional[constr(min_length=0, max_length=100)] = None
    organisation: OrganisationDto = None
    building: Optional[BuildingDto] = None
    location: Optional[LocationDto] = None
    integration: Optional[IntegrationDto] = None


class IntegrationDto(BaseModel):
    id: Optional[int] = None
    integrationType: IntegrationType
    userDefined: bool
    settings: Optional[Dict[str, str]] = None
    alias: str
    organisation: OrganisationDto = None

BuildingDto.update_forward_refs()
LocationDto.update_forward_refs()
LocationProfileDto.update_forward_refs()
OrganisationDto.update_forward_refs()
DeviceDto.update_forward_refs()

# Feedback forms
class FormQuestionType(Enum):
    TEXT = 'Text'
    MULTIPLE_CHOICE = 'MultipleChoice'
    SINGLE_CHOICE = 'SingleChoice'

class FormQuestionBase(BaseModel):
    name: str
    type: str

class FormQuestionResponse(BaseModel):
    date: Optional[date] = None

class FormTextQuestionResponse(FormQuestionResponse):
    id: int
    username: str
    response: str

class FormTextQuestionDto(FormQuestionBase):
    type: str = Field('Text',const=True)
    responses: Optional[List[FormTextQuestionResponse]]

class FormChoiceQuestionResponse(FormQuestionResponse):
    value: str
    count: int

class FormChoiceQuestionBase(FormQuestionBase):
    responsesPerDate: Optional[List[FormChoiceQuestionResponse]]
    
class FormSingleChoiceQuestionDto(FormChoiceQuestionBase):
    type: str = Field('SingleChoice',const=True)

class FormMultipleChoiceQuestionDto(FormChoiceQuestionBase):
    type: str = Field('MultipleChoice',const=True)

FormQuestionType = Union[
        FormTextQuestionDto,
        FormSingleChoiceQuestionDto,
        FormMultipleChoiceQuestionDto
    ]